<?php

/**
* @author PayPay, PAYPAYUE- Instituição de Pagamento, Unipessoal, Lda
* @package VirtueMart
* @subpackage payment
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* VirtueMart is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
*
* http://virtuemart.org
*/

if (!extension_loaded('soap')) {
    vmError(vmText::sprintf('Ativar o soap no servidor!', 'soap'));
}

if (!defined('_VALID_MOS') && !defined('_JEXEC')) {
    die('Direct Access to '.basename(__FILE__).' is not allowed.');
}

if (!class_exists('vmPSPlugin')) {
    require(JPATH_VM_PLUGINS.DS.'vmpsplugin.php');
}

class plgVmPaymentPaypay extends vmPSPlugin
{
    public function __construct(& $subject, $config)
    {
        parent::__construct($subject, $config);
        $this->_loggable = true;
        $this->tableFields = array_keys($this->getTableSQLFields());
        $varsToPush = array(
            'platformCode'     => array(null, 'char'),
            'hash'             => array(null, 'char'),
            'nif'              => array(null, 'char'),
            'environment'      => array(0, 'char'),
            'paymentType'      => array(0, 'char'),
            'payment_currency' => array(0, 'char'),
            'payment_logos'    => array('', 'char'),
            'countries'        => array('', 'char')
        );

        $this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
    }

    protected function getVmPluginCreateTableSQL()
    {
        return $this->createTableSQL('Payment Paypay Table');
    }

    public function getTableSQLFields()
    {
        $SQLfields = array('id' => 'int(1) unsigned NOT NULL AUTO_INCREMENT', 'virtuemart_order_id' => 'int(11) UNSIGNED DEFAULT NULL', 'order_number' => 'char(32) DEFAULT NULL', 'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED DEFAULT NULL', 'payment_name' => 'char(255) NOT NULL DEFAULT \'\' ', 'payment_currency' => 'char(3) ', 'url' => ' char(255)  DEFAULT NULL', 'token' => ' char(255)  DEFAULT NULL', 'idTransaction' => ' char(255)  DEFAULT NULL', 'value' => ' char(10) NOT NULL DEFAULT \'0\' ', 'tax_id' => 'smallint(11) DEFAULT NULL', 'estado' => 'smallint(1) DEFAULT 0');

        return $SQLfields;
    }

    /**
     * Função invocada após clicar no botão "Confirm Purchase"
     * @param  [type] $cart  [description]
     * @param  [type] $order [description]
     * @return [type]        [description]
     */
    public function plgVmConfirmedOrder($cart, $order)
    {
        if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }

        $lang = JFactory::getLanguage();
        $filename = 'com_virtuemart';
        $lang->load($filename, JPATH_ADMINISTRATOR);
        $vendorId = 0;

        $html = "";

        if (!class_exists('VirtueMartModelOrders')) {
            require(JPATH_VM_ADMINISTRATOR.DS.'models'.DS.'orders.php');
        }
        $this->getPaymentCurrency($method);
        // END printing out HTML Form code (Payment Extra Info)
        $q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="'.$method->payment_currency.'" ';
        $db = & JFactory::getDBO();
        $db->setQuery($q);
        $currency_code_3 = $db->loadResult();
        $paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
        $totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false), 2);
        $totalInCents = number_format($totalInPaymentCurrency, 2, '', '');
        $amount = $totalInCents;
        $cd = CurrencyDisplay::getInstance($cart->pricesCurrency);

        $pagamento = $this->getUrlPayment($cart, $method, $order);

        $this->_virtuemart_paymentmethod_id = $order['details']['BT']->virtuemart_paymentmethod_id;

        $dbValues['payment_name'] = $this->renderPluginName($method);
        $dbValues['order_number'] = $order['details']['BT']->order_number;
        $dbValues['virtuemart_paymentmethod_id'] = $this->_virtuemart_paymentmethod_id;
        $dbValues['payment_currency'] = $currency_code_3;
        $dbValues['value'] = $totalInPaymentCurrency;
        $dbValues['url'] = $pagamento->url;
        $dbValues['token'] = $pagamento->token;
        $dbValues['idTransaction'] = $pagamento->idTransaction;
        $dbValues['estado'] = 0;
        $this->storePSPluginInternalData($dbValues);

        $html = "A sua encomenda foi registada, para efetuar o seu pagamento clique <a href=".$pagamento->url.">aqui!</a>";
        
        $modelOrder = VmModel::getModel('orders');

        $order['order_status'] = 'U';
        $order['customer_notified'] = 1;
        $order['comments'] = $html;
        $modelOrder->updateStatusForOneOrder($order['details']['BT']->virtuemart_order_id, $order, true);

        //We delete the old stuff
        $cart->emptyCart();
        JRequest::setVar('html', $html);
        $app = JFactory::getApplication();
        $app->redirect($pagamento->url);
        return true;
    }

    private function getPaypayOptions($webServiceURL)
    {
        $classmap = array(
            'RequestEntity'                     => 'RequestEntity',
            'ResponseIntegrationState'          => 'ResponseIntegrationState',
            'RequestInterval'                   => 'RequestInterval',
            'RequestPaymentReference'           => 'RequestPaymentReference',
            'ResponseEntityPayments'            => 'ResponseEntityPayments',
            'ResponseEntityPaymentReferences'   => 'ResponseEntityPaymentReferences',
            'RequestCreditCardPayment'          => 'RequestCreditCardPayment',
            'RequestBuyerInfo'                  => 'RequestBuyerInfo',
            'RequestBillingAddress'             => 'RequestBillingAddress',
            'RequestShippingAddress'            => 'RequestShippingAddress',
            'ResponseCreditCardPayment'         => 'ResponseCreditCardPayment',
            'RequestReferenceDetails'           => 'RequestReferenceDetails',
            'ResponseGetPayment'                => 'ResponseGetPayment',
            'RequestPaymentOrder'               => 'RequestPaymentOrder',
            'RequestWebhook'                    => 'RequestWebhook',
        );

        foreach ($classmap as $class => $v) {
            if (!class_exists($class)) {
                require_once dirname(__FILE__) . "/paypay/structures/" . $class . ".php";
            }
        }

        $options = array(
            'classmap'   => $classmap,
            'location'   => $webServiceURL,
            'cache_wsdl' => WSDL_CACHE_NONE
        );

        return $options;
    }

    private function getUrlPayment($cart, $method, $order)
    {
        $paymentMethod       = $method->paymentType;
        $webServiceURL  = $this->getWebServiceURLAndWSDL($method)['webServiceURL'];
        $webServiceWSDL = $this->getWebServiceURLAndWSDL($method)['webServiceWSDL'];

        $options = $this->getPaypayOptions($webServiceURL);

        $paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
        $totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false), 2);
        $totalInCents = number_format($totalInPaymentCurrency, 2, '', '');
        $amount = $totalInCents;

        $cancelLink = JURI::base().substr(JRoute::_('index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&tmpl=component&plg=paypay&action=cancel', false, 0), strlen(JURI::base(true)) + 1);
        
        $successPaymentLink = JURI::base().substr(JRoute::_('index.php?option=com_virtuemart&view=orders&layout=details&order_number=' . $order['details']['BT']->order_number, false, 0), strlen(JURI::base(true)) + 1);

        $returnLink = $successPaymentLink;

        $client = new SoapClient($webServiceWSDL, $options);
        $requestEntity  = $this->createRequestEntity($method);
        $encomenda = new RequestPaymentOrder(
            array(
                'amount'=>(int)$amount,
                'productCode' => $order['details']['BT']->order_number
            )
        );
        
        //Get ISO 3166 2 digit country codes from Billing and Shipping Address
        $countryBillingIso = shopfunctions::getCountryByID($order['details']['BT']->virtuemart_country_id, 'country_2_code');
        $countryShippingIso = shopfunctions::getCountryByID($order['details']['ST']->virtuemart_country_id, 'country_2_code');

        
        $stateBillingIso = shopfunctions::getStateByID($order['details']['BT']->virtuemart_state_id, 'state_2_code');
        $stateBillingName = shopfunctions::getStateByID($order['details']['BT']->virtuemart_state_id, 'state_name');

        $stateShippingIso = shopfunctions::getStateByID($order['details']['ST']->virtuemart_state_id, 'state_2_code');
        $stateShippingName = shopfunctions::getStateByID($order['details']['ST']->virtuemart_state_id, 'state_name');


        $customer = new RequestBuyerInfo(
            array(
                'lastName'   => $order['details']['BT']->last_name,
                'firstName'  => $order['details']['BT']->first_name,
                'customerId' => $order['details']['BT']->virtuemart_user_id,
                'email'      => $order['details']['BT']->email
            )
        );

        $billingAddress = new RequestBillingAddress(
            $countryBillingIso,
            $stateBillingIso,
            $stateBillingName,
            $order['details']['BT']->city,
            $order['details']['BT']->address_1,
            $order['details']['BT']->address_2,
            $order['details']['BT']->zip
        );

        $shippingAddress = new RequestShippingAddress(
            $countryShippingIso,
            $stateShippingIso,
            $stateShippingName,
            $order['details']['ST']->city,
            $order['details']['ST']->address_1,
            $order['details']['ST']->address_2,
            $order['details']['ST']->zip
        );
        
        $payment = new RequestCreditCardPayment(
            $encomenda,
            $successPaymentLink,
            $cancelLink,
            $returnLink,
            $customer,
            $paymentMethod,
            $billingAddress,
            $shippingAddress
        );

        try {
            $paymentDetails  = $client->doWebPayment($requestEntity, $payment);
            if ($paymentDetails) {
                return $paymentDetails;
            } else {
                return false;
            }
        } catch (SoapFault $error) {
            $error = 0;
            return $error;
        }
    }

    /**
     * Display stored payment data for an order
     *
     */
    public function plgVmOnShowOrderBEPayment($virtuemart_order_id, $virtuemart_payment_id)
    {
        if (!$this->selectedThisByMethodId($virtuemart_payment_id)) {
            return null; // Another method was selected, do nothing
        }

        if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id))) {
            return null;
        }

        vmLanguage::loadJLang('com_virtuemart');

        $html = '<table class="adminlist table">' . "\n";
        $html .= $this->getHtmlHeaderBE();
        $html .= $this->getHtmlRowBE('COM_VIRTUEMART_PAYMENT_NAME', $paymentTable->payment_name);
        $html .= $this->getHtmlRowBE('STANDARD_PAYMENT_TOTAL_CURRENCY', $paymentTable->payment_order_total . ' ' . $paymentTable->payment_currency);
        if ($paymentTable->email_currency) {
            $html .= $this->getHtmlRowBE('STANDARD_EMAIL_CURRENCY', $paymentTable->email_currency);
        }
        $html .= '</table>' . "\n";
        return $html;
    }

    public function getCosts(VirtueMartCart $cart, $method, $cart_prices)
    {
        return (0 + ($cart_prices['salesPrice'] * 0));
    }

    protected function checkConditions($cart, $method, $cart_prices)
    {
        $address = (($cart->ST == 0) ? $cart->BT : $cart->ST);

        $countries = array();
        if (!empty($method->countries)) {
            if (!is_array($method->countries)) {
                $countries[0] = $method->countries;
            } else {
                $countries = $method->countries;
            }
        }

        // probably did not gave his BT:ST address
        if (!is_array($address)) {
            $address = array();
            $address['virtuemart_country_id'] = 0;
        }

        if (!isset($address['virtuemart_country_id'])) {
            $address['virtuemart_country_id'] = 0;
        }
        if (count($countries) == 0 || in_array($address['virtuemart_country_id'], $countries)) {
            return true;
        }

        return false;
    }

    public function createRequestEntity($method)
    {
        $payment_params = str_replace(["|", "\""], ["&", ""], $method->get("payment_params"));
        parse_str($payment_params, $paymentParams);

        $PayPayEncryptionKey = $paymentParams["hash"];
        $PayPayPlataformCode = $paymentParams["platformCode"];
        $PayPayNIF           = $paymentParams["nif"];

        $dateTime      = new DateTime();
        $dateTime      = $dateTime->modify('+10 minutes');
        $dateTime      = $dateTime->format('d-m-Y H:i:s');
        $hash          = hash("sha256", $PayPayEncryptionKey.$dateTime);
        $lang          = substr(JFactory::getLanguage()->getTag(), 0, 2);
        $info          = array(
                            'Joomla!'    => JVersion::getShortVersion(),
                            'VirtueMart' => vmVersion::$RELEASE
                        );
        
        $requestEntity = new RequestEntity($PayPayPlataformCode, $hash, $dateTime, $PayPayNIF, $lang, $info);

        return $requestEntity;
    }

    private function getWebServiceURLAndWSDL($method)
    {
        if (!defined('PAYPAY_WEBSERVICE_URL') && !defined('PAYPAY_WEBSERVICE_WSDL')) {
            if ($method->environment) {
                //PRODUÇÃO
                $webServiceURL  = 'https://www.paypay.pt/paypay/index.php/paypayservices/paypayservices_c/server';
                $webServiceWSDL = 'https://www.paypay.pt/paypay/index.php/paypayservices/paypayservices_c/wsdl';
            } else {
                //TESTE
                $webServiceURL  = 'https://paypay.acin.pt/paypaybeta/index.php/paypayservices/paypayservices_c/server';
                $webServiceWSDL = 'https://paypay.acin.pt/paypaybeta/index.php/paypayservices/paypayservices_c/wsdl';
            }
        } else {
            $webServiceURL  = constant('PAYPAY_WEBSERVICE_URL');
            $webServiceWSDL = constant('PAYPAY_WEBSERVICE_WSDL');
        }

        return array(
            'webServiceURL'  => $webServiceURL,
            'webServiceWSDL' => $webServiceWSDL
        );
    }

    private function checkIntegration($method)
    {
        $webServiceURL  = $this->getWebServiceURLAndWSDL($method)['webServiceURL'];
        $webServiceWSDL = $this->getWebServiceURLAndWSDL($method)['webServiceWSDL'];

        $options        = $this->getPaypayOptions($webServiceURL);
        $client         = new SoapClient($webServiceWSDL, $options);
        $requestEntity  = $this->createRequestEntity($method);

        try {
            $response = $client->checkIntegrationState($requestEntity);
            //check sucess of the request
            if ($response->state == "1") {
                return true;
            } else {
                return false;
            }
        } catch (SoapFault $error) {
            $error = 0;
            return $error;
        }
    }

    private function subscribeToWebhook($method)
    {
        $webServiceURL  = $this->getWebServiceURLAndWSDL($method)['webServiceURL'];
        $webServiceWSDL = $this->getWebServiceURLAndWSDL($method)['webServiceWSDL'];
        $options        = $this->getPaypayOptions($webServiceURL);
        $client         = new SoapClient($webServiceWSDL, $options);
        $requestEntity  = $this->createRequestEntity($method);

        $url = JURI::base().substr(JRoute::_('index.php?option=com_virtuemart&view=pluginresponse&pm='.$method->virtuemart_paymentmethod_id.'&task=pluginnotification&tmpl=component&plg=paypay&action=webhook', false, 0), strlen(JURI::base(true)) + 1);
        $url = str_replace('/administrator', '', $url);
        
        $requestWebhook = new RequestWebhook(
            array(
                'action' => 'payment_confirmed',
                'url'    => $url
            )
        );

        try {
            $response = $client->subscribeToWebhook($requestEntity, $requestWebhook);
        } catch (Exception $e) {
            return false;
        }
        if ($response->integrationState->state == "1") {
            return true;
        } else {
            return false;
        }
    }

    public function plgVmOnStoreInstallPaymentPluginTable($jplugin_id)
    {
        return $this->onStoreInstallPluginTable($jplugin_id);
    }

    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart, &$msg)
    {
        return $this->OnSelectCheck($cart);
    }

    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected, &$htmlIn)
    {
        return $this->displayListFE($cart, $selected, $htmlIn);
    }

    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name)
    {
        return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    public function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId)
    {
        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return null; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return false;
        }
        $this->getPaymentCurrency($method);

        $paymentCurrencyId = $method->payment_currency;
    }

    public function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices, &$paymentCounter)
    {
        return $this->onCheckAutomaticSelected($cart, $cart_prices);
    }

    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name)
    {
        $this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

    public function plgVmonShowOrderPrintPayment($order_number, $method_id)
    {
        return $this->onShowOrderPrint($order_number, $method_id);
    }

    public function plgVmSetOnTablePluginParamsPayment($name, $id, &$table)
    {
        return $this->setOnTablePluginParams($name, $id, $table);
    }

    public function plgVmDeclarePluginParamsPaymentVM3(&$data)
    {
        if ($this->checkIntegration($data)) {
            if (!$this->subscribeToWebhook($data)) {
                JError::raiseWarning(100, 'Os dados introduzidos não estão corretos!');
            } else {
                JFactory::getApplication()->enqueueMessage('Os dados introduzidos estão corretos');
            }
        } else {
            JError::raiseWarning(100, 'Os dados introduzidos não estão corretos!');
        }

        return $this->declarePluginParams('payment', $data);
    }

    private function concludePayment($post)
    {
        $methodId = vRequest::getInt('pm', 0);

        if ($methodId == 0) {
            header('HTTP/1.1 403 Forbidden');
            echo "Método de pagamento obrigatório";
            die();
        }

        $this->_currentMethod = $this->getVmPluginMethod($methodId);
        $paypaySignatureKey = $this->_currentMethod->hash;

        $body = file_get_contents("php://input");
        $signature = str_replace(',', '&', $_SERVER['HTTP_PAYPAY_SIGNATURE']);
        parse_str($signature, $output);

        $confirmation_hash = hash_hmac('sha256', $body.$output['ts'], $paypaySignatureKey);
        $timeout = (int)($output['ts']) < (time() - 1800);

        if (!hash_equals($output['hash'], $confirmation_hash) || $timeout) {
            header('HTTP/1.1 403 Forbidden');
            die();
        }

        foreach ($post['payments'] as $payment) {
            $db = &JFactory::getDBO();
            $q = 'SELECT id, virtuemart_order_id FROM `' . $this->_tablename . '` WHERE idTransaction = ' . $db->quote($payment['paymentId'], true) . ' AND estado = 0';
            $db->setQuery($q, 0, 1);
            $callback_fetch = $db->loadRow();

            if (empty($callback_fetch)) {
                continue;
            }

            $orderID = $callback_fetch[1];

            $modelOrder = VmModel::getModel('orders');

            $orderStatus = $modelOrder->getOrder($orderID)['details']['BT']->order_status;

            if ($orderStatus != 'P' && $orderStatus != 'U') {
                continue;
            }

            $orderArr = array();
            $orderArr["order_status"] = 'C';
            $orderArr['customer_notified'] = 1;
            $orderArr['comments'] = "Pagamento da encomenda confirmado";


            $modelOrder->updateStatusForOneOrder($orderID, $orderArr);

            $db->setQuery('UPDATE `' . $this->_tablename . '` SET estado = 1 WHERE id = ' .$callback_fetch[0].' AND virtuemart_order_id = ' .$orderID.'     AND estado = 0');
            $db->execute();
        }
        header('HTTP/1.1 200 Ok');
        return true;
    }

    public function cancelOrder($token)
    {
        $db = &JFactory::getDBO();
        $q = 'SELECT id, virtuemart_order_id,order_number FROM `' . $this->_tablename . '` WHERE token = ' . $db->quote($token, true) . ' AND estado = 0';
        $db->setQuery($q, 0, 1);
        $callback_fetch = $db->loadRow();

        if (empty($callback_fetch)) {
            return false;
        }

        $orderID = $callback_fetch[1];

        $modelOrder = VmModel::getModel('orders');

        $orderArr = array();
        $orderArr["order_status"] = 'X';
        $orderArr['comments'] = "Pagamento cancelado pelo comprador";

        try {
            $modelOrder->updateStatusForOneOrder($orderID, $orderArr);

            $db->setQuery('UPDATE `' . $this->_tablename . '` SET estado = 2 WHERE id = ' .$callback_fetch[0].' AND virtuemart_order_id = ' .$orderID.' AND estado = 0');
            $db->execute();
        } catch (Exception $ex) {
        }

        return array(
            'state' => true,
            'orderNumber' => $callback_fetch[2]
        );
    }

    public function plgVmOnPaymentNotification()
    {
        require_once(JPATH_VM_ADMINISTRATOR.DS.'models'.DS.'orders.php');

        $parameter = $_GET;

        if (empty($parameter['plg'])) {
            return false;
        }

        if ($parameter['plg']!='paypay') {
            return false;
        }

        if (isset($parameter['action'])) {
            if ($parameter['action']=='cancel') {
                $token = $parameter['token'];
                $orderStatus = $this->cancelOrder($token);
                if ($orderStatus['state']) {
                    $app = JFactory::getApplication();
                    $app->enqueueMessage("A Encomenda foi cancelada!", 'Warning');
                    $app->redirect(JRoute::_('index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$orderStatus['orderNumber']));
                }
            } elseif ($parameter['action']=='webhook') {
                $post = $_POST;
                $this->concludePayment($post);
                die;
            }
        }
    }
}

// No closing tag
